////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  File: main.c
//  Author: Johloemoe
//  Date: 11/22/2003
//  Description: Main Game File
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////








#include "main.h" // include main file
#include "back.raw.c" // include Gfx "GameBlade Logo"
#include "paddle.raw.c" // include Gfx for the Paddle
#include "ball.raw.c" // include Gfx for the ball
//#include "gback.raw.c" //this includes a background for the Game (the file gets too big if i use it >1MB)

int Init(int Mode) { // Init GFX


	if(Mode=NTSC)
	VIDEO_Init(VIDEO_640X480_NTSC_YUV16);
	if(Mode=PAL50)
	VIDEO_Init(VIDEO_640X480_PAL50_YUV16);
	if(Mode=PAL60)
	VIDEO_Init(VIDEO_640X480_PAL60_YUV16);
	else
	VIDEO_Init(VIDEO_640X480_NTSC_YUV16);

	VIDEO_SetFrameBuffer(VIDEO_FRAMEBUFFER_BOTH, (u32)fb);
	DEBUG_InitText(fb, COLOR_WHITE);	



	return 1;
}

int Begin() { // Begin function, called in the begin of every frame 
	VIDEO_WaitVSync(); // Wait for VSync	
	PAD_ReadState(&gb_Pad[0], PAD_CHANNEL_0); //Read out Pad channel
	PAD_ReadState(&gb_Pad[1], PAD_CHANNEL_1); // -""-

	return 1;
}

int clfb() { // Clears the screen 
	RENDER_ClearFrameBuffer(fb, COLOR_BLACK); // clear framebuffer
	return 1;
}


int IntroGB() { // The intro function

	bg.height=BACK_HEIGHT; // Some Bitmap infos
	bg.width=BACK_WIDTH;
	bg.x=90; // PosX of the Bmp
	bg.y=100; // PosY ...	
	while(TRUE) { // Loop
        Begin(); // Begin	
	clfb(); // clear framebuffer

	int x,y,bitmappos; //some counters for the rendering
	for(y=bg.y;y<bg.y+bg.height;y++){
		for(x=bg.x;x<bg.x+(bg.width/2);x++){
			bitmappos=x-bg.x+((y-bg.y)*bg.width)/2+(bg.width/2)*(bg.height)*0;
			fb[x+320*y]=back_Bitmap[bitmappos]; 
		} // Rendering Loop ( by DesktopMan , messy buit helpful)
	}
	if(gb_Pad[0].Digital.Start) //When START is pressed, continue
	break;
	

	DEBUG_Print(30, 380, "GameBlade v0.1 - Intro"); //some text

	DEBUG_Print(30, 420, "(c)Rinen/Johloemoe 2003");
	}
	return 1;
}


int Menu() { // Menu function

	int current=0; // The variable for the selection
	while(TRUE) { // Loop
        Begin(); // Begin	
	clfb(); // Clear framebufffer

	if(gb_Pad[0].Digital.A) { // When A is pressed 

	if(current==1) // When selection  is 1 then turn ai off
	AISWITCH=OFF;

	if(current==0) // When selection is 0 turn AI on
	AISWITCH=ON;

	if(current==2) // When selection is 2 reset the GC
	M_HOTRESET;

	break; // Continue to game
	}
	if(gb_Pad[0].Analog.Y < -30 && current!=0) // When Analog Stick is moved up, move indicator up
	current-=1;

	if(gb_Pad[0].Analog.Y > 30 && current!=2) // ... move indicator down
	current+=1;

	DEBUG_Print(200, 200, "Pong! v1.0 Beta"); // Some text
	DEBUG_Print(200, 230, "Main Menu");


	if(current==0) // Indicator 
	DEBUG_Print(80,300, "->");

	if(current==1)
	DEBUG_Print(80,330, "->");

	if(current==2)
	DEBUG_Print(80,360, "->");

	DEBUG_Print(110, 300, "Single Player Mode"); // Menu Items

	DEBUG_Print(110, 330, "Multi Player Mode");

	DEBUG_Print(110, 360, "End (reset)");
	}

	return 1;
}


int InitGame() { // Initializes the Game
	bg.height=BACK_HEIGHT; // bmpo infos
	bg.width=BACK_WIDTH;
	bg.x=100;// Pos of the bmp
	bg.y=200; 
	ball.height=BALL_HEIGHT;
	ball.width=BALL_WIDTH;
	ball.x=160;
	ball.y=240;
	ball.sx=(BS/2); // Ball speed
	ball.sy=BS;
	paddle[0].height=PADDLE_HEIGHT;
	paddle[0].width=PADDLE_WIDTH;
	paddle[0].x=30;
	paddle[0].y=240;
	paddle[0].points=0;
	paddle[1].height=PADDLE_HEIGHT;
	paddle[1].width=PADDLE_WIDTH;
	paddle[1].x=290;
	paddle[1].y=240;
	paddle[1].points=0;
	return 1;
}

int Render() { // Render all images, render routine by desktopMan
	int x,y,bitmappos;
	for(y=bg.y;y<bg.y+bg.height;y++){
		for(x=bg.x;x<bg.x+(bg.width/2);x++){
			bitmappos=x-bg.x+((y-bg.y)*bg.width)/2;
			fb[x+320*y]=back_Bitmap[bitmappos]; 
		}
	} 
	for(y=ball.y;y<ball.y+ball.height;y++){
		for(x=ball.x;x<ball.x+(ball.width/2);x++){
			bitmappos=x-ball.x+((y-ball.y)*ball.width)/2;
			fb[x+320*y]=ball_Bitmap[bitmappos]; 
		}
	}
	for(y=paddle[0].y;y<paddle[0].y+paddle[0].height;y++){
		for(x=paddle[0].x;x<paddle[0].x+(paddle[0].width/2);x++){
			bitmappos=x-paddle[0].x+((y-paddle[0].y)*paddle[0].width)/2;
			fb[x+320*y]=paddle_Bitmap[bitmappos]; 
		}
	}
	for(y=paddle[1].y;y<paddle[1].y+paddle[1].height;y++){
		for(x=paddle[1].x;x<paddle[1].x+(paddle[1].width/2);x++){
			bitmappos=x-paddle[1].x+((y-paddle[1].y)*paddle[1].width)/2;
			fb[x+320*y]=paddle_Bitmap[bitmappos]; 
		}
	}
	DEBUG_Print(180,30,"Pong! 0.9 beta"); // Some text
	DEBUG_Print(180,50,"by Johloemoe");
	DEBUG_ShowValueU8(20,20,(u8)paddle[0].points);  //The scores
	DEBUG_ShowValueU8(600,20,(u8)paddle[1].points);
	
	return 1;
}


int Input() { // Handles input
	if(gb_Pad[0].Analog.Y >30 && paddle[0].y+75<460)
	paddle[0].y+=4;
	if(gb_Pad[0].Analog.Y <-30 && paddle[0].y>20)
	paddle[0].y-=4;

	if(AISWITCH==OFF) { // Do this only when AI is not activated
	if(gb_Pad[1].Analog.Y >30 && paddle[1].y+75<460)
	paddle[1].y+=4;
	if(gb_Pad[1].Analog.Y <-30 && paddle[1].y>20)
	paddle[1].y-=4;
	}
	return 1;
}

int AI () { // Handles AI (or what it should be)
/*	if(ball.y+40 >paddle[0].y && paddle[0].y+75<460)
	paddle[0].y+=4;
	if(ball.y <paddle[0].y && paddle[0].y>20)
	paddle[0].y-=4; */
	if(AISWITCH==ON){ // Do only when AI is turned on
	if(ball.y+40 >paddle[1].y && paddle[1].y+75<460)
	paddle[1].y+=4;
	if(ball.y <paddle[1].y && paddle[1].y>20)
	paddle[1].y-=4;
	}
	return 1;
}
	

int HitDet(int x1, int y1, int w1, int h1,int x2, int y2, int w2, int h2){ // Hit detection by DesktopMan
	if(x1+w1>x2&&x1<x2+w2&&y1+h1>y2&&y1<y2+h2)
		return 1;
	return 0;
}

int Coldet() { // Handles collision detection and boundaries
	if(ball.x<=30){
	ball.sx=(BS/2);
	paddle[1].points++;
	}
	if(ball.x>=290){
	ball.sx=-(BS/2);
	paddle[0].points++;
	}
	if(ball.y<=20)
	ball.sy=BS;
	if(ball.y>=440)
	ball.sy=-BS;

	if(HitDet(paddle[0].x,paddle[0].y,24,75,ball.x,ball.y,16,16))
		ball.sx=(BS/2);

	if(HitDet(paddle[1].x,paddle[1].y,24,75,ball.x,ball.y,16,16))
		ball.sx=-(BS/2);

	ball.x+=ball.sx;
	ball.y+=ball.sy;
	return 1;
}
	 
	

int main() // Main func
{	

	Init(PAL60); // Init Game
	while(TRUE)  
	{
	IntroGB(); // Show intro
	Menu();// Show menu
	InitGame();//Init the Game

   while(TRUE) // Game Loop
   {

	Begin(); // Begin	
	clfb(); // Clear the framebuffer
	Render(); // Render 
	Input(); // ...
	AI();//...
	Coldet();//...
	

	if(gb_Pad[0].Digital.Start && gb_Pad[0].Digital.A) // Reset
	{
	   M_HOTRESET;
	}
	if(gb_Pad[0].Digital.Start && gb_Pad[0].Digital.B) // Return to main menu
	{
	   break;
	}
   }
	}
   return TRUE;
}
